int iCheckSpell(object oPC, int iBard, int iCleric, int iDruid, int iPaladin, int iRanger, int iSorcerer, int iWizard);

//Define Spell Levels By Class Level
const int B0=0, B1=3, B2=5, B3=8, B4=11, B5=14, B6=17;
const int C0=0, C1=1, C2=3, C3=5, C4=7, C5=9, C6=11, C7=13, C8=15, C9=17;
const int D0=0, D1=1, D2=3, D3=5, D4=7, D5=9, D6=11, D7=13, D8=15, D9=17;
const int P0=0, P1=6, P2=10, P3=12, P4=15;
const int R0=0, R1=6, R2=10, R3=12, R4=15;
const int S0=0, S1=1, S2=4, S3=6, S4=8, S5=10, S6=12, S7=14, S8=16, S9=18;
const int W0=0, W1=1, W2=3, W3=5, W4=7, W5=9, W6=11, W7=13, W8=15, W9=17;

void main()
{
  object oSelf = OBJECT_SELF;
  object oPC = GetLastOpenedBy();
  SetLocalObject(oPC,"oLastOpened",OBJECT_SELF);
  int iScribeType = 0;  //Change this value to a '1' to have all spells castable by the character
                        //Appear in the scribes desk, instead of just which spells are
                        //currently castable

  if (GetItemPossessedBy(oPC,"NoDrop_SkillLogBook")==OBJECT_INVALID)
   {
    CreateItemOnObject("skilllogbook",oPC,1);
   }


  if (GetHitDice(oPC)<7)
   {
    FloatingTextStringOnCreature("You are not seasoned enough to scribe anything.",oPC,FALSE);
    return;
   }

  int iWizardLevel=GetLevelByClass(CLASS_TYPE_WIZARD,oPC);
  int iClericLevel=GetLevelByClass(CLASS_TYPE_CLERIC,oPC);
  int iSorcererLevel=GetLevelByClass(CLASS_TYPE_SORCERER,oPC);
  int iDruidLevel=GetLevelByClass(CLASS_TYPE_DRUID,oPC);
  int iBardLevel=GetLevelByClass(CLASS_TYPE_BARD,oPC);
  int iRangerLevel=GetLevelByClass(CLASS_TYPE_RANGER,oPC);
  int iPaladinLevel=GetLevelByClass(CLASS_TYPE_PALADIN,oPC);
  int iThiefLevel=GetLevelByClass(CLASS_TYPE_ROGUE,oPC);

  if ((iWizardLevel<7)&&(iClericLevel<7)&&(iSorcererLevel<7)&&(iDruidLevel<7)
       &&(iBardLevel<7)&&(iRangerLevel<7)&&(iPaladinLevel<7))
   {
    FloatingTextStringOnCreature("You are not seasoned enough in any spellcasting profession to scribe anything.",oPC,FALSE);
    return;
   }

  int iScrollType = GetLocalInt(oPC,"iUseThisParchment");
  int iScribeMode = GetLocalInt(oPC,"iScribeMode");

  if (iScrollType!=0) CreateItemOnObject("flagswitch051",oSelf,1); //Normal Parchment
  if (iScrollType!=1) CreateItemOnObject("flagswitch052",oSelf,1); //Black Parchment
  if (iScrollType!=2) CreateItemOnObject("flagswitch053",oSelf,1); //White Parchment

  if (iScribeMode!=0) CreateItemOnObject("flagswitch054",oSelf,1); //Scribe Spells
  if (iScribeMode!=1) CreateItemOnObject("flagswitch055",oSelf,1); //Prepare Ink


  //Now to determine the scrolls which appear in the container for the inscriptionist

  if (iScribeType==1)
   {
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe001",oSelf,1); //Acid Fog
    if (iCheckSpell(oPC,B0,C3,D0,P0,R0,S5,W5)==1) CreateItemOnObject("scribe002",oSelf,1); //Animate Dead
    if (iCheckSpell(oPC,B3,C3,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe003",oSelf,1); //Bestow Curse
    if (iCheckSpell(oPC,B2,C3,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe004",oSelf,1); //Blindness/Deafness
    if (iCheckSpell(oPC,B2,C2,D2,P2,R0,S2,W2)==1) CreateItemOnObject("scribe005",oSelf,1); //Bull's Strength
    if (iCheckSpell(oPC,B0,C0,D0,P0,R2,S1,W1)==1) CreateItemOnObject("scribe006",oSelf,1); //Burning Hands
    if (iCheckSpell(oPC,B2,C0,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe007",oSelf,1); //Cat's Grace
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe008",oSelf,1); //Chain Lightning
    if (iCheckSpell(oPC,B3,C0,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe009",oSelf,1); //Charm Monster
    if (iCheckSpell(oPC,B1,C0,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe010",oSelf,1); //Charm Person
    if (iCheckSpell(oPC,B0,C0,D2,P0,R0,S0,W0)==1) CreateItemOnObject("scribe011",oSelf,1); //Charm Person or Animal
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe012",oSelf,1); //Circle of Death
    if (iCheckSpell(oPC,B3,C0,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe013",oSelf,1); //Clairaudience and Clairvoyance
    if (iCheckSpell(oPC,B2,C3,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe014",oSelf,1); //Clarity
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S5,W5)==1) CreateItemOnObject("scribe015",oSelf,1); //Cloudkill
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe016",oSelf,1); //Color Spray
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S5,W5)==1) CreateItemOnObject("scribe017",oSelf,1); //Cone of Cold
    if (iCheckSpell(oPC,B3,C0,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe018",oSelf,1); //Confusion
    if (iCheckSpell(oPC,B0,C3,D3,P0,R0,S4,W4)==1) CreateItemOnObject("scribe019",oSelf,1); //Contagion
    if (iCheckSpell(oPC,B0,C6,D0,P0,R0,S7,W7)==1) CreateItemOnObject("scribe020",oSelf,1); //Control Undead
    if (iCheckSpell(oPC,B2,C2,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe021",oSelf,1); //Darkness
    if (iCheckSpell(oPC,B1,C0,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe022",oSelf,1); //Daze
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S7,W7)==1) CreateItemOnObject("scribe023",oSelf,1); //Delayed Blast Fireball
    if (iCheckSpell(oPC,B4,C4,D0,P0,R0,S5,W5)==1) CreateItemOnObject("scribe024",oSelf,1); //Dismissal
    if (iCheckSpell(oPC,B3,C3,D4,P3,R0,S3,W3)==1) CreateItemOnObject("scribe025",oSelf,1); //Dispel Magic
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S9,W9)==1) CreateItemOnObject("scribe026",oSelf,1); //Dominate Monster
    if (iCheckSpell(oPC,B4,C0,D0,P0,R0,S5,W5)==1) CreateItemOnObject("scribe027",oSelf,1); //Dominate Person
    if (iCheckSpell(oPC,B2,C2,D0,P2,R0,S2,W2)==1) CreateItemOnObject("scribe028",oSelf,1); //Eagle's Splendor
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe029",oSelf,1); //Elemental Shield
    if (iCheckSpell(oPC,B0,C2,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe030",oSelf,1); //Endurance
    if (iCheckSpell(oPC,B0,C1,D1,P1,R0,S1,W1)==1) CreateItemOnObject("scribe031",oSelf,1); //Endure Elements
    if (iCheckSpell(oPC,B0,C9,D0,P0,R0,S9,W9)==1) CreateItemOnObject("scribe032",oSelf,1); //Energy Drain
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe033",oSelf,1); //Enervation
    if (iCheckSpell(oPC,B5,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe034",oSelf,1); //Etheral Visage
    if (iCheckSpell(oPC,B3,C0,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe035",oSelf,1); //Fear
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S5,W5)==1) CreateItemOnObject("scribe036",oSelf,1); //Feeblemind
    if (iCheckSpell(oPC,B0,C0,D8,P0,R0,S7,W7)==1) CreateItemOnObject("scribe037",oSelf,1); //Finger of Death
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe038",oSelf,1); //Fireball
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe039",oSelf,1); //Flame Arrow
    if (iCheckSpell(oPC,B2,C2,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe040",oSelf,1); //Fox's Cunning
    if (iCheckSpell(oPC,B0,C9,D0,P0,R0,S9,W9)==1) CreateItemOnObject("scribe041",oSelf,1); //Gate
    if (iCheckSpell(oPC,B2,C0,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe042",oSelf,1); //Ghostly Visage
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe043",oSelf,1); //Ghoul Touch
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe044",oSelf,1); //Globe of Invulnerability
    if (iCheckSpell(oPC,B1,C0,D1,P0,R1,S1,W1)==1) CreateItemOnObject("scribe045",oSelf,1); //Grease
    if (iCheckSpell(oPC,B5,C6,D6,P0,R0,S6,W6)==1) CreateItemOnObject("scribe046",oSelf,1); //Greater Dispelling
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S8,W8)==1) CreateItemOnObject("scribe047",oSelf,1); //Greater Planar Binding
    if (iCheckSpell(oPC,B0,C7,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe048",oSelf,1); //Greater Restoration
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S5,W5)==1) CreateItemOnObject("scribe049",oSelf,1); //Greater Shadow Conjuration
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe050",oSelf,1); //Greater Spell Breach
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S9,W9)==1) CreateItemOnObject("scribe051",oSelf,1); //Greater Spell Mantle
    if (iCheckSpell(oPC,B0,C0,D6,P0,R0,S6,W6)==1) CreateItemOnObject("scribe052",oSelf,1); //Greater Stoneskin
    if (iCheckSpell(oPC,B3,C0,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe053",oSelf,1); //Haste
    if (iCheckSpell(oPC,B4,C0,D4,P0,R0,S5,W5)==1) CreateItemOnObject("scribe054",oSelf,1); //Hold Monster
    if (iCheckSpell(oPC,B2,C2,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe055",oSelf,1); //Hold Person
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S8,W8)==1) CreateItemOnObject("scribe056",oSelf,1); //Horrid Wilting
    if (iCheckSpell(oPC,B1,C0,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe057",oSelf,1); //Identify
    if (iCheckSpell(oPC,B4,C0,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe058",oSelf,1); //Improved Invisibility
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S8,W8)==1) CreateItemOnObject("scribe059",oSelf,1); //Incendiary Cloud
    if (iCheckSpell(oPC,B2,C0,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe060",oSelf,1); //Invisibility
    if (iCheckSpell(oPC,B3,C0,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe061",oSelf,1); //Invisibility Sphere
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe062",oSelf,1); //Knock
    if (iCheckSpell(oPC,B1,C2,D2,P0,R0,S2,W2)==1) CreateItemOnObject("scribe063",oSelf,1); //Lesser Dispel
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S5,W5)==1) CreateItemOnObject("scribe064",oSelf,1); //Lesser Mind Blank
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S5,W5)==1) CreateItemOnObject("scribe065",oSelf,1); //Lesser Planar Binding
    if (iCheckSpell(oPC,B0,C2,D2,P0,R0,S0,W0)==1) CreateItemOnObject("scribe066",oSelf,1); //Lesser Restoration
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe067",oSelf,1); //Lesser Spell Breach
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S5,W5)==1) CreateItemOnObject("scribe068",oSelf,1); //Lesser Spell Mantle
    if (iCheckSpell(oPC,B1,C1,D1,P0,R0,S1,W1)==1) CreateItemOnObject("scribe069",oSelf,1); //Light
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe070",oSelf,1); //Lightning Bolt
    if (iCheckSpell(oPC,B1,C0,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe071",oSelf,1); //Mage Armor
    if (iCheckSpell(oPC,B3,C3,D0,P3,R0,S3,W3)==1) CreateItemOnObject("scribe072",oSelf,1); //Magic Circle against Alignment
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe073",oSelf,1); //Magic Missile
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S8,W8)==1) CreateItemOnObject("scribe074",oSelf,1); //Mass Blindness/Deafness
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S8,W8)==1) CreateItemOnObject("scribe075",oSelf,1); //Mass Charm
    if (iCheckSpell(oPC,B6,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe076",oSelf,1); //Mass Haste
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe077",oSelf,1); //Melf's Acid Arrow
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S9,W9)==1) CreateItemOnObject("scribe078",oSelf,1); //Meteor Swarm
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S8,W8)==1) CreateItemOnObject("scribe079",oSelf,1); //Mind Blank
    if (iCheckSpell(oPC,B5,C0,D0,P0,R0,S5,W5)==1) CreateItemOnObject("scribe080",oSelf,1); //Mind Fog
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe081",oSelf,1); //Minor Globe of Invulnerability
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S9,W9)==1) CreateItemOnObject("scribe082",oSelf,1); //Mordenkainen's Disjunction
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S7,W7)==1) CreateItemOnObject("scribe083",oSelf,1); //Mordenkainen's Sword
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe084",oSelf,1); //Negative Energy Burst
    if (iCheckSpell(oPC,B0,C2,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe085",oSelf,1); //Negative Energy Ray
    if (iCheckSpell(oPC,B4,C4,D3,P4,R3,S0,W0)==1) CreateItemOnObject("scribe086",oSelf,1); //Neutralize Poison
    if (iCheckSpell(oPC,B2,C2,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe087",oSelf,1); //Owl's Wisdom
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe088",oSelf,1); //Phantasmal Killer
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe089",oSelf,1); //Planar Binding
    if (iCheckSpell(oPC,B0,C0,D0,P0,R4,S4,W4)==1) CreateItemOnObject("scribe090",oSelf,1); //Polymorph Self
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S9,W9)==1) CreateItemOnObject("scribe091",oSelf,1); //Power Word, Kill
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S7,W7)==1) CreateItemOnObject("scribe092",oSelf,1); //Power Word, Stun
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S8,W8)==1) CreateItemOnObject("scribe093",oSelf,1); //Premonition
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S7,W7)==1) CreateItemOnObject("scribe094",oSelf,1); //Prismatic Spray
    if (iCheckSpell(oPC,B1,C1,D0,P1,R0,S1,W1)==1) CreateItemOnObject("scribe095",oSelf,1); //Protection from Alignment
    if (iCheckSpell(oPC,B0,C3,D3,P0,R2,S3,W3)==1) CreateItemOnObject("scribe096",oSelf,1); //Protection from Elements
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S7,W7)==1) CreateItemOnObject("scribe097",oSelf,1); //Protection from Spells
    if (iCheckSpell(oPC,B0,C5,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe098",oSelf,1); //Raise Dead
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe099",oSelf,1); //Ray of Enfeeblement
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe100",oSelf,1); //Ray of Frost  --#100
    if (iCheckSpell(oPC,B0,C3,D0,P3,R0,S4,W4)==1) CreateItemOnObject("scribe101",oSelf,1); //Remove Blindness/Deafness
    if (iCheckSpell(oPC,B3,C3,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe102",oSelf,1); //Remove Curse
    if (iCheckSpell(oPC,B3,C3,D3,P0,R3,S0,W0)==1) CreateItemOnObject("scribe103",oSelf,1); //Remove Disease
    if (iCheckSpell(oPC,B0,C2,D2,P2,R1,S2,W2)==1) CreateItemOnObject("scribe104",oSelf,1); //Resist Elements
    if (iCheckSpell(oPC,B1,C1,D1,P1,R0,S1,W1)==1) CreateItemOnObject("scribe105",oSelf,1); //Resistance
    if (iCheckSpell(oPC,B0,C4,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe106",oSelf,1); //Restoration
    if (iCheckSpell(oPC,B0,C7,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe107",oSelf,1); //Resurrection
    if (iCheckSpell(oPC,B1,C1,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe108",oSelf,1); //Scare
    if (iCheckSpell(oPC,B2,C0,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe109",oSelf,1); //See Invisibility
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe110",oSelf,1); //Shades
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe111",oSelf,1); //Shadow Conjuration
    if (iCheckSpell(oPC,B0,C0,D9,P0,R0,S9,W9)==1) CreateItemOnObject("scribe112",oSelf,1); //Shapechange
    if (iCheckSpell(oPC,B2,C2,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe113",oSelf,1); //Silence
    if (iCheckSpell(oPC,B1,C0,D0,P0,R2,S1,W1)==1) CreateItemOnObject("scribe114",oSelf,1); //Sleep
    if (iCheckSpell(oPC,B3,C0,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe115",oSelf,1); //Slow
    if (iCheckSpell(oPC,B2,C2,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe116",oSelf,1); //Sound Burst
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S7,W7)==1) CreateItemOnObject("scribe117",oSelf,1); //Spell Mantle
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe118",oSelf,1); //Stinking Cloud
    if (iCheckSpell(oPC,B0,C0,D4,P0,R0,S4,W4)==1) CreateItemOnObject("scribe119",oSelf,1); //Stoneskin
    if (iCheckSpell(oPC,B1,C1,D1,P0,R1,S1,W1)==1) CreateItemOnObject("scribe120",oSelf,1); //Summon Creature I
    if (iCheckSpell(oPC,B2,C2,D2,P0,R2,S2,W2)==1) CreateItemOnObject("scribe121",oSelf,1); //Summon Creature II
    if (iCheckSpell(oPC,B3,C3,D3,P0,R3,S3,W3)==1) CreateItemOnObject("scribe122",oSelf,1); //Summon Creature III
    if (iCheckSpell(oPC,B4,C4,D4,P0,R4,S4,W4)==1) CreateItemOnObject("scribe123",oSelf,1); //Summon Creature IV
    if (iCheckSpell(oPC,B0,C9,D9,P0,R0,S9,W9)==1) CreateItemOnObject("scribe124",oSelf,1); //Summon Creature IX
    if (iCheckSpell(oPC,B0,C5,D5,P0,R0,S5,W5)==1) CreateItemOnObject("scribe125",oSelf,1); //Summon Creature V
    if (iCheckSpell(oPC,B0,C6,D6,P0,R0,S6,W6)==1) CreateItemOnObject("scribe126",oSelf,1); //Summon Creature VI
    if (iCheckSpell(oPC,B0,C7,D7,P0,R0,S7,W7)==1) CreateItemOnObject("scribe127",oSelf,1); //Summon Creature VII
    if (iCheckSpell(oPC,B0,C8,D8,P0,R0,S8,W8)==1) CreateItemOnObject("scribe128",oSelf,1); //Summon Creature VIII
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe129",oSelf,1); //Tenser's Transformation
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S9,W9)==1) CreateItemOnObject("scribe130",oSelf,1); //Time Stop
    if (iCheckSpell(oPC,B0,C5,D7,P0,R0,S6,W6)==1) CreateItemOnObject("scribe131",oSelf,1); //True Seeing
    if (iCheckSpell(oPC,B2,C2,D1,P0,R1,S1,W2)==1) CreateItemOnObject("scribe132",oSelf,1); //Ultravision
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe133",oSelf,1); //Vampiric Touch
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S9,W9)==1) CreateItemOnObject("scribe134",oSelf,1); //Wail of the Banshee
    if (iCheckSpell(oPC,B0,C0,D5,P0,R0,S4,W4)==1) CreateItemOnObject("scribe135",oSelf,1); //Wall of Fire
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe136",oSelf,1); //Web
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S9,W9)==1) CreateItemOnObject("scribe137",oSelf,1); //Weird
    if (iCheckSpell(oPC,B1,C1,D1,P0,R0,S0,W0)==1) CreateItemOnObject("scribe138",oSelf,1); //Cure Minor Wounds #138
    if (iCheckSpell(oPC,B1,C1,D1,P1,R1,S0,W0)==1) CreateItemOnObject("scribe139",oSelf,1); //Cure Light Wounds #139
    if (iCheckSpell(oPC,B2,C2,D3,P3,R3,S0,W0)==1) CreateItemOnObject("scribe140",oSelf,1); //Cure Moderate Wounds
    if (iCheckSpell(oPC,B3,C3,D4,P4,R4,S0,W0)==1) CreateItemOnObject("scribe141",oSelf,1); //Cure Serious Wounds
    if (iCheckSpell(oPC,B3,C2,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe142",oSelf,1); //Find Traps
    if (iCheckSpell(oPC,B0,C2,D0,P2,R3,S0,W0)==1) CreateItemOnObject("scribe143",oSelf,1); //Aid
    if (iCheckSpell(oPC,B0,C0,D7,P0,R0,S0,W0)==1) CreateItemOnObject("scribe144",oSelf,1); //Aura of Vitality
    if (iCheckSpell(oPC,B0,C8,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe145",oSelf,1); //Aura versus Alignment
    if (iCheckSpell(oPC,B0,C0,D5,P0,R0,S0,W0)==1) CreateItemOnObject("scribe146",oSelf,1); //Awaken
    if (iCheckSpell(oPC,B0,C0,D2,P0,R0,S0,W0)==1) CreateItemOnObject("scribe147",oSelf,1); //BarkSkin
    if (iCheckSpell(oPC,B0,C6,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe148",oSelf,1); //Blade Barrier
    if (iCheckSpell(oPC,B0,C1,D0,P1,R0,S0,W0)==1) CreateItemOnObject("scribe149",oSelf,1); //Bless
    if (iCheckSpell(oPC,B0,C0,D3,P0,R0,S0,W0)==1) CreateItemOnObject("scribe150",oSelf,1); //Call Lightning #150
    if (iCheckSpell(oPC,B0,C5,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe151",oSelf,1); //Circle of Doom
    if (iCheckSpell(oPC,B0,C8,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe152",oSelf,1); //Create Greater Undead
    if (iCheckSpell(oPC,B0,C6,D0,P0,R0,S8,W8)==1) CreateItemOnObject("scribe153",oSelf,1); //Create Undead
    if (iCheckSpell(oPC,B0,C0,D7,P0,R0,S0,W0)==1) CreateItemOnObject("scribe154",oSelf,1); //Creeping Doom
    if (iCheckSpell(oPC,B4,C4,D5,P0,R0,S0,W0)==1) CreateItemOnObject("scribe155",oSelf,1); //Cure Critical Wounds
    if (iCheckSpell(oPC,B0,C4,D5,P4,R0,S0,W0)==1) CreateItemOnObject("scribe156",oSelf,1); //Death Ward
    if (iCheckSpell(oPC,B0,C7,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe157",oSelf,1); //Destruction
    if (iCheckSpell(oPC,B0,C4,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe158",oSelf,1); //Divine Power
    if (iCheckSpell(oPC,B0,C0,D3,P0,R0,S0,W0)==1) CreateItemOnObject("scribe159",oSelf,1); //Dominate Animal
    if (iCheckSpell(oPC,B0,C1,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe160",oSelf,1); //Doom #160
    if (iCheckSpell(oPC,B0,C0,D9,P0,R0,S0,W0)==1) CreateItemOnObject("scribe161",oSelf,1); //Elemental Swarm
    if (iCheckSpell(oPC,B6,C0,D6,P0,R0,S0,W0)==1) CreateItemOnObject("scribe162",oSelf,1); //Energy Buffer
    if (iCheckSpell(oPC,B0,C0,D1,P0,R1,S0,W0)==1) CreateItemOnObject("scribe163",oSelf,1); //Entangle
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe164",oSelf,1); //Evard's Black Tentacles
    if (iCheckSpell(oPC,B0,C8,D7,P0,R0,S0,W0)==1) CreateItemOnObject("scribe165",oSelf,1); //Fire Storm
    if (iCheckSpell(oPC,B0,C0,D2,P0,R0,S0,W0)==1) CreateItemOnObject("scribe166",oSelf,1); //Flame Lash
    if (iCheckSpell(oPC,B0,C5,D4,P0,R0,S0,W0)==1) CreateItemOnObject("scribe167",oSelf,1); //Flame Strike
    if (iCheckSpell(oPC,B0,C4,D4,P4,R4,S0,W0)==1) CreateItemOnObject("scribe168",oSelf,1); //Freedom of Movement
    if (iCheckSpell(oPC,B0,C4,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe169",oSelf,1); //Hammer of the Gods
    if (iCheckSpell(oPC,B0,C6,D7,P0,R0,S0,W0)==1) CreateItemOnObject("scribe170",oSelf,1); //Harm #170
    if (iCheckSpell(oPC,B0,C6,D7,P0,R0,S0,W0)==1) CreateItemOnObject("scribe171",oSelf,1); //Heal
    if (iCheckSpell(oPC,B5,C5,D6,P0,R0,S0,W0)==1) CreateItemOnObject("scribe172",oSelf,1); //Healing Circle
    if (iCheckSpell(oPC,B0,C0,D2,P0,R2,S0,W0)==1) CreateItemOnObject("scribe173",oSelf,1); //Hold Animal
    if (iCheckSpell(oPC,B6,C0,D5,P0,R0,S4,W4)==1) CreateItemOnObject("scribe174",oSelf,1); //Ice Storm
    if (iCheckSpell(oPC,B0,C9,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe175",oSelf,1); //Implosion
    if (iCheckSpell(oPC,B0,C3,D0,P0,R3,S0,W0)==1) CreateItemOnObject("scribe176",oSelf,1); //Invisibility Purge
    if (iCheckSpell(oPC,B4,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe177",oSelf,1); //Legend Lore
    if (iCheckSpell(oPC,B0,C8,D9,P0,R0,S0,W0)==1) CreateItemOnObject("scribe178",oSelf,1); //Mass Heal
    if (iCheckSpell(oPC,B0,C0,D8,P0,R0,S0,W0)==1) CreateItemOnObject("scribe179",oSelf,1); //Nature's Balance
    if (iCheckSpell(oPC,B0,C3,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe180",oSelf,1); //Negative Energy Protection #180
    if (iCheckSpell(oPC,B0,C4,D3,P0,R0,S0,W0)==1) CreateItemOnObject("scribe181",oSelf,1); //Poison
    if (iCheckSpell(oPC,B0,C3,D0,P3,R0,S0,W0)==1) CreateItemOnObject("scribe182",oSelf,1); //Prayer
    if (iCheckSpell(oPC,B0,C7,D6,P0,R0,S0,W0)==1) CreateItemOnObject("scribe183",oSelf,1); //Regenerate
    if (iCheckSpell(oPC,B0,C1,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe184",oSelf,1); //Remove Fear
    if (iCheckSpell(oPC,B0,C2,D0,P2,R0,S0,W0)==1) CreateItemOnObject("scribe185",oSelf,1); //Remove Paralysis
    if (iCheckSpell(oPC,B0,C1,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe186",oSelf,1); //Sanctuary
    if (iCheckSpell(oPC,B0,C3,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe187",oSelf,1); //Searing Light
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S7,W7)==1) CreateItemOnObject("scribe188",oSelf,1); //Shadow Shield
    if (iCheckSpell(oPC,B0,C5,D5,P0,R0,S0,W0)==1) CreateItemOnObject("scribe189",oSelf,1); //Slay Living
    if (iCheckSpell(oPC,B0,C5,D5,P0,R0,S0,W0)==1) CreateItemOnObject("scribe190",oSelf,1); //Spell Resistance #190
    if (iCheckSpell(oPC,B0,C9,D9,P0,R0,S0,W0)==1) CreateItemOnObject("scribe191",oSelf,1); //Storm of Vengeance
    if (iCheckSpell(oPC,B0,C8,D8,P0,R0,S0,W0)==1) CreateItemOnObject("scribe192",oSelf,1); //Sunbeam
    if (iCheckSpell(oPC,B0,C1,D1,P1,R0,S0,W0)==1) CreateItemOnObject("scribe193",oSelf,1); //Virtue
    if (iCheckSpell(oPC,B4,C0,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe194",oSelf,1); //War Cry
    if (iCheckSpell(oPC,B0,C7,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe195",oSelf,1); //Word of Faith


    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe197",oSelf,1); //Acid Splash
    if (iCheckSpell(oPC,B1,C0,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe198",oSelf,1); //Amplify
    if (iCheckSpell(oPC,B0,C0,D0,P2,R0,S0,W0)==1) CreateItemOnObject("scribe199",oSelf,1); //Aura of Glory
    if (iCheckSpell(oPC,B1,C0,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe200",oSelf,1); //Balagarn's Iron Horn
    if (iCheckSpell(oPC,B0,C1,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe201",oSelf,1); //Bane
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S8,W8)==1) CreateItemOnObject("scribe202",oSelf,1); //Bigby's Clenched Fist
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S9,W9)==1) CreateItemOnObject("scribe203",oSelf,1); //Bigby's Crushing Hand
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe204",oSelf,1); //Bigby's Forceful Hand
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S7,W7)==1) CreateItemOnObject("scribe205",oSelf,1); //Bigby's Grasping Hand
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S5,W5)==1) CreateItemOnObject("scribe206",oSelf,1); //Bigby's Interposing Hand
    if (iCheckSpell(oPC,B0,C0,D2,P0,R0,S0,W0)==1) CreateItemOnObject("scribe207",oSelf,1); //Blood Frenzy
    if (iCheckSpell(oPC,B0,C0,D8,P0,R0,S0,W0)==1) CreateItemOnObject("scribe208",oSelf,1); //Bombardment
    if (iCheckSpell(oPC,B0,C3,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe209",oSelf,1); //Continual Flame
    if (iCheckSpell(oPC,B6,C0,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe210",oSelf,1); //Dirge
    if (iCheckSpell(oPC,B3,C0,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe211",oSelf,1); //Displacement
    if (iCheckSpell(oPC,B0,C1,D0,P1,R0,S0,W0)==1) CreateItemOnObject("scribe212",oSelf,1); //Divine Favor
    if (iCheckSpell(oPC,B0,C4,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe213",oSelf,1); //Divine Might
    if (iCheckSpell(oPC,B0,C0,D6,P0,R0,S0,W0)==1) CreateItemOnObject("scribe214",oSelf,1); //Drown
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe215",oSelf,1); //Electric Jolt
    if (iCheckSpell(oPC,B0,C1,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe216",oSelf,1); //Entropic Shield
    if (iCheckSpell(oPC,B1,C0,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe217",oSelf,1); //Expeditious Retreat
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S5,W5)==1) CreateItemOnObject("scribe218",oSelf,1); //Firebrand
    if (iCheckSpell(oPC,B1,C0,D1,P0,R0,S1,W1)==1) CreateItemOnObject("scribe219",oSelf,1); //Flare
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe220",oSelf,1); //Flesh To Stone
    if (iCheckSpell(oPC,B0,C0,D3,P0,R3,S0,W0)==1) CreateItemOnObject("scribe221",oSelf,1); //Greater Magic Fang
    if (iCheckSpell(oPC,B0,C6,D0,P0,R0,S8,W8)==1) CreateItemOnObject("scribe222",oSelf,1); //Greater Sanctuary
    if (iCheckSpell(oPC,B3,C0,D0,P0,R0,S3,W3)==1) CreateItemOnObject("scribe223",oSelf,1); //Gust of Wind
    if (iCheckSpell(oPC,B0,C0,D5,P0,R0,S0,W0)==1) CreateItemOnObject("scribe224",oSelf,1); //Inferno
    if (iCheckSpell(oPC,B0,C4,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe225",oSelf,1); //Inflict Critical Wounds
    if (iCheckSpell(oPC,B0,C1,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe226",oSelf,1); //Inflict Light Wounds
    if (iCheckSpell(oPC,B0,C1,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe227",oSelf,1); //Inflict Minor Wounds
    if (iCheckSpell(oPC,B0,C2,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe228",oSelf,1); //Inflict Moderate wounds
    if (iCheckSpell(oPC,B0,C3,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe229",oSelf,1); //Inflict Serious Wounds
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S4,W4)==1) CreateItemOnObject("scribe230",oSelf,1); //Isaac's Lesser Missile Storm
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe231",oSelf,1); //Isaac's Greater Missile Storm
    if (iCheckSpell(oPC,B0,C0,D1,P0,R1,S0,W0)==1) CreateItemOnObject("scribe232",oSelf,1); //Magic Fang
    if (iCheckSpell(oPC,B0,C0,D4,P0,R4,S0,W0)==1) CreateItemOnObject("scribe233",oSelf,1); //Mass Camouflage
    if (iCheckSpell(oPC,B0,C0,D2,P0,R2,S0,W0)==1) CreateItemOnObject("scribe234",oSelf,1); //One With The Land
    if (iCheckSpell(oPC,B0,C0,D5,P0,R0,S0,W0)==1) CreateItemOnObject("scribe235",oSelf,1); //Owl's Insight (#235)
    if (iCheckSpell(oPC,B0,C6,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe236",oSelf,1); //Planar Ally
    if (iCheckSpell(oPC,B0,C0,D3,P0,R0,S0,W0)==1) CreateItemOnObject("scribe237",oSelf,1); //Quillfire
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe238",oSelf,1); //Shield
    if (iCheckSpell(oPC,B0,C1,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe239",oSelf,1); //Shield of Faith
    if (iCheckSpell(oPC,B0,C0,D3,P0,R0,S0,W0)==1) CreateItemOnObject("scribe240",oSelf,1); //Spike Growth
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S6,W6)==1) CreateItemOnObject("scribe241",oSelf,1); //Stone To Flesh
    if (iCheckSpell(oPC,B0,C0,D8,P0,R0,S8,W8)==1) CreateItemOnObject("scribe242",oSelf,1); //Sunburst
    if (iCheckSpell(oPC,B2,C0,D0,P0,R0,S2,W2)==1) CreateItemOnObject("scribe243",oSelf,1); //Tasha's Hideous Laughter
    if (iCheckSpell(oPC,B0,C0,D0,P0,R0,S1,W1)==1) CreateItemOnObject("scribe244",oSelf,1); //True Strike
    if (iCheckSpell(oPC,B0,C9,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe245",oSelf,1); //Undeath's Eternal Foe
    if (iCheckSpell(oPC,B3,C0,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe246",oSelf,1); //Wounding Whispers
   }

  if (iScribeType==0)
   {
    if (GetHasSpell(SPELL_ACID_FOG,oPC)>0) CreateItemOnObject("scribe001",oSelf,1); //Acid Fog
    if (GetHasSpell(SPELL_ANIMATE_DEAD,oPC)>0) CreateItemOnObject("scribe002",oSelf,1); //Animate Dead
    if (GetHasSpell(SPELL_BESTOW_CURSE,oPC)>0) CreateItemOnObject("scribe003",oSelf,1); //Bestow Curse
    if (GetHasSpell(SPELL_BLINDNESS_AND_DEAFNESS,oPC)>0) CreateItemOnObject("scribe004",oSelf,1); //Blindness/Deafness
    if (GetHasSpell(SPELL_BULLS_STRENGTH,oPC)>0) CreateItemOnObject("scribe005",oSelf,1); //Bull's Strength
    if (GetHasSpell(SPELL_BURNING_HANDS,oPC)>0) CreateItemOnObject("scribe006",oSelf,1); //Burning Hands
    if (GetHasSpell(SPELL_CATS_GRACE,oPC)>0) CreateItemOnObject("scribe007",oSelf,1); //Cat's Grace
    if (GetHasSpell(SPELL_CHAIN_LIGHTNING,oPC)>0) CreateItemOnObject("scribe008",oSelf,1); //Chain Lightning
    if (GetHasSpell(SPELL_CHARM_MONSTER,oPC)>0) CreateItemOnObject("scribe009",oSelf,1); //Charm Monster
    if (GetHasSpell(SPELL_CHARM_PERSON,oPC)>0) CreateItemOnObject("scribe010",oSelf,1); //Charm Person
    if (GetHasSpell(SPELL_CHARM_PERSON_OR_ANIMAL,oPC)>0) CreateItemOnObject("scribe011",oSelf,1); //Charm Person or Animal
    if (GetHasSpell(SPELL_CIRCLE_OF_DEATH,oPC)>0) CreateItemOnObject("scribe012",oSelf,1); //Circle of Death
    if (GetHasSpell(SPELL_CLAIRAUDIENCE_AND_CLAIRVOYANCE,oPC)>0) CreateItemOnObject("scribe013",oSelf,1); //Clairaudience and Clairvoyance
    if (GetHasSpell(SPELL_CLARITY,oPC)>0) CreateItemOnObject("scribe014",oSelf,1); //Clarity
    if (GetHasSpell(SPELL_CLOUDKILL,oPC)>0) CreateItemOnObject("scribe015",oSelf,1); //Cloudkill
    if (GetHasSpell(SPELL_COLOR_SPRAY,oPC)>0) CreateItemOnObject("scribe016",oSelf,1); //Color Spray
    if (GetHasSpell(SPELL_CONE_OF_COLD,oPC)>0) CreateItemOnObject("scribe017",oSelf,1); //Cone of Cold
    if (GetHasSpell(SPELL_CONFUSION,oPC)>0) CreateItemOnObject("scribe018",oSelf,1); //Confusion
    if (GetHasSpell(SPELL_CONTAGION,oPC)>0) CreateItemOnObject("scribe019",oSelf,1); //Contagion
    if (GetHasSpell(SPELL_CONTROL_UNDEAD,oPC)>0) CreateItemOnObject("scribe020",oSelf,1); //Control Undead
    if (GetHasSpell(SPELL_DARKNESS,oPC)>0) CreateItemOnObject("scribe021",oSelf,1); //Darkness
    if (GetHasSpell(SPELL_DAZE,oPC)>0) CreateItemOnObject("scribe022",oSelf,1); //Daze
    if (GetHasSpell(SPELL_DELAYED_BLAST_FIREBALL,oPC)>0) CreateItemOnObject("scribe023",oSelf,1); //Delayed Blast Fireball
    if (GetHasSpell(SPELL_DISMISSAL,oPC)>0) CreateItemOnObject("scribe024",oSelf,1); //Dismissal
    if (GetHasSpell(SPELL_DISPEL_MAGIC,oPC)>0) CreateItemOnObject("scribe025",oSelf,1); //Dispel Magic
    if (GetHasSpell(SPELL_DOMINATE_MONSTER,oPC)>0) CreateItemOnObject("scribe026",oSelf,1); //Dominate Monster
    if (GetHasSpell(SPELL_DOMINATE_PERSON,oPC)>0) CreateItemOnObject("scribe027",oSelf,1); //Dominate Person
    if (GetHasSpell(SPELL_EAGLE_SPLEDOR,oPC)>0) CreateItemOnObject("scribe028",oSelf,1); //Eagle's Splendor
    if (GetHasSpell(SPELL_ELEMENTAL_SHIELD,oPC)>0) CreateItemOnObject("scribe029",oSelf,1); //Elemental Shield
    if (GetHasSpell(SPELL_ENDURANCE,oPC)>0) CreateItemOnObject("scribe030",oSelf,1); //Endurance
    if (GetHasSpell(SPELL_ENDURE_ELEMENTS,oPC)>0) CreateItemOnObject("scribe031",oSelf,1); //Endure Elements
    if (GetHasSpell(SPELL_ENERGY_DRAIN,oPC)>0) CreateItemOnObject("scribe032",oSelf,1); //Energy Drain
    if (GetHasSpell(SPELL_ENERVATION,oPC)>0) CreateItemOnObject("scribe033",oSelf,1); //Enervation
    if (GetHasSpell(SPELL_ETHEREAL_VISAGE,oPC)>0) CreateItemOnObject("scribe034",oSelf,1); //Etheral Visage
    if (GetHasSpell(SPELL_FEAR,oPC)>0) CreateItemOnObject("scribe035",oSelf,1); //Fear
    if (GetHasSpell(SPELL_FEEBLEMIND,oPC)>0) CreateItemOnObject("scribe036",oSelf,1); //Feeblemind
    if (GetHasSpell(SPELL_FINGER_OF_DEATH,oPC)>0) CreateItemOnObject("scribe037",oSelf,1); //Finger of Death
    if (GetHasSpell(SPELL_FIREBALL,oPC)>0) CreateItemOnObject("scribe038",oSelf,1); //Fireball
    if (GetHasSpell(SPELL_FLAME_ARROW,oPC)>0) CreateItemOnObject("scribe039",oSelf,1); //Flame Arrow
    if (GetHasSpell(SPELL_FOXS_CUNNING,oPC)>0) CreateItemOnObject("scribe040",oSelf,1); //Fox's Cunning
    if (GetHasSpell(SPELL_GATE,oPC)>0) CreateItemOnObject("scribe041",oSelf,1); //Gate
    if (GetHasSpell(SPELL_GHOSTLY_VISAGE,oPC)>0) CreateItemOnObject("scribe042",oSelf,1); //Ghostly Visage
    if (GetHasSpell(SPELL_GHOUL_TOUCH,oPC)>0) CreateItemOnObject("scribe043",oSelf,1); //Ghoul Touch
    if (GetHasSpell(SPELL_GLOBE_OF_INVULNERABILITY,oPC)>0) CreateItemOnObject("scribe044",oSelf,1); //Globe of Invulnerability
    if (GetHasSpell(SPELL_GREASE,oPC)>0) CreateItemOnObject("scribe045",oSelf,1); //Grease
    if (GetHasSpell(SPELL_GREATER_DISPELLING,oPC)>0) CreateItemOnObject("scribe046",oSelf,1); //Greater Dispelling
    if (GetHasSpell(SPELL_GREATER_PLANAR_BINDING,oPC)>0) CreateItemOnObject("scribe047",oSelf,1); //Greater Planar Binding
    if (GetHasSpell(SPELL_GREATER_RESTORATION,oPC)>0) CreateItemOnObject("scribe048",oSelf,1); //Greater Restoration

    //Hope this works LOL
    if ((GetHasSpell(SPELL_GREATER_SHADOW_CONJURATION_ACID_ARROW,oPC)>0)||
        (GetHasSpell(SPELL_GREATER_SHADOW_CONJURATION_MINOR_GLOBE,oPC)>0)||
        (GetHasSpell(SPELL_GREATER_SHADOW_CONJURATION_MIRROR_IMAGE,oPC)>0)||
        (GetHasSpell(SPELL_GREATER_SHADOW_CONJURATION_SUMMON_SHADOW,oPC)>0)||
        (GetHasSpell(SPELL_GREATER_SHADOW_CONJURATION_WEB,oPC)>0)) CreateItemOnObject("scribe049",oSelf,1); //Greater Shadow Conjuration



    if (GetHasSpell(SPELL_GREATER_SPELL_BREACH,oPC)>0) CreateItemOnObject("scribe050",oSelf,1); //Greater Spell Breach
    if (GetHasSpell(SPELL_GREATER_SPELL_MANTLE,oPC)>0) CreateItemOnObject("scribe051",oSelf,1); //Greater Spell Mantle
    if (GetHasSpell(SPELL_GREATER_STONESKIN,oPC)>0) CreateItemOnObject("scribe052",oSelf,1); //Greater Stoneskin
    if (GetHasSpell(SPELL_HASTE,oPC)>0) CreateItemOnObject("scribe053",oSelf,1); //Haste
    if (GetHasSpell(SPELL_HOLD_MONSTER,oPC)>0) CreateItemOnObject("scribe054",oSelf,1); //Hold Monster
    if (GetHasSpell(SPELL_HOLD_PERSON,oPC)>0) CreateItemOnObject("scribe055",oSelf,1); //Hold Person
    if (GetHasSpell(SPELL_HORRID_WILTING,oPC)>0) CreateItemOnObject("scribe056",oSelf,1); //Horrid Wilting
    if (GetHasSpell(SPELL_IDENTIFY,oPC)>0) CreateItemOnObject("scribe057",oSelf,1); //Identify
    if (GetHasSpell(SPELL_IMPROVED_INVISIBILITY,oPC)>0) CreateItemOnObject("scribe058",oSelf,1); //Improved Invisibility
    if (GetHasSpell(SPELL_INCENDIARY_CLOUD,oPC)>0) CreateItemOnObject("scribe059",oSelf,1); //Incendiary Cloud
    if (GetHasSpell(SPELL_INVISIBILITY,oPC)>0) CreateItemOnObject("scribe060",oSelf,1); //Invisibility
    if (GetHasSpell(SPELL_INVISIBILITY_SPHERE,oPC)>0) CreateItemOnObject("scribe061",oSelf,1); //Invisibility Sphere
    if (GetHasSpell(SPELL_KNOCK,oPC)>0) CreateItemOnObject("scribe062",oSelf,1); //Knock
    if (GetHasSpell(SPELL_LESSER_DISPEL,oPC)>0) CreateItemOnObject("scribe063",oSelf,1); //Lesser Dispel
    if (GetHasSpell(SPELL_LESSER_MIND_BLANK,oPC)>0) CreateItemOnObject("scribe064",oSelf,1); //Lesser Mind Blank
    if (GetHasSpell(SPELL_LESSER_PLANAR_BINDING,oPC)>0) CreateItemOnObject("scribe065",oSelf,1); //Lesser Planar Binding
    if (GetHasSpell(SPELL_LESSER_RESTORATION,oPC)>0) CreateItemOnObject("scribe066",oSelf,1); //Lesser Restoration
    if (GetHasSpell(SPELL_LESSER_SPELL_BREACH,oPC)>0) CreateItemOnObject("scribe067",oSelf,1); //Lesser Spell Breach
    if (GetHasSpell(SPELL_LESSER_SPELL_MANTLE,oPC)>0) CreateItemOnObject("scribe068",oSelf,1); //Lesser Spell Mantle
    if (GetHasSpell(SPELL_LIGHT,oPC)>0) CreateItemOnObject("scribe069",oSelf,1); //Light
    if (GetHasSpell(SPELL_LIGHTNING_BOLT,oPC)>0) CreateItemOnObject("scribe070",oSelf,1); //Lightning Bolt
    if (GetHasSpell(SPELL_MAGE_ARMOR,oPC)>0) CreateItemOnObject("scribe071",oSelf,1); //Mage Armor

    if ((GetHasSpell(SPELL_MAGIC_CIRCLE_AGAINST_CHAOS,oPC)>0)||
        (GetHasSpell(SPELL_MAGIC_CIRCLE_AGAINST_EVIL,oPC)>0)||
        (GetHasSpell(SPELL_MAGIC_CIRCLE_AGAINST_GOOD,oPC)>0)||
        (GetHasSpell(SPELL_MAGIC_CIRCLE_AGAINST_LAW,oPC)>0))CreateItemOnObject("scribe072",oSelf,1); //Magic Circle against Alignment


    if (GetHasSpell(SPELL_MAGIC_MISSILE,oPC)>0) CreateItemOnObject("scribe073",oSelf,1); //Magic Missile
    if (GetHasSpell(SPELL_MASS_BLINDNESS_AND_DEAFNESS,oPC)>0) CreateItemOnObject("scribe074",oSelf,1); //Mass Blindness/Deafness
    if (GetHasSpell(SPELL_MASS_CHARM,oPC)>0) CreateItemOnObject("scribe075",oSelf,1); //Mass Charm
    if (GetHasSpell(SPELL_MASS_HASTE,oPC)>0) CreateItemOnObject("scribe076",oSelf,1); //Mass Haste
    if (GetHasSpell(SPELL_MELFS_ACID_ARROW,oPC)>0) CreateItemOnObject("scribe077",oSelf,1); //Melf's Acid Arrow
    if (GetHasSpell(SPELL_METEOR_SWARM,oPC)>0) CreateItemOnObject("scribe078",oSelf,1); //Meteor Swarm
    if (GetHasSpell(SPELL_MIND_BLANK,oPC)>0) CreateItemOnObject("scribe079",oSelf,1); //Mind Blank
    if (GetHasSpell(SPELL_MIND_FOG,oPC)>0) CreateItemOnObject("scribe080",oSelf,1); //Mind Fog
    if (GetHasSpell(SPELL_MINOR_GLOBE_OF_INVULNERABILITY,oPC)>0) CreateItemOnObject("scribe081",oSelf,1); //Minor Globe of Invulnerability
    if (GetHasSpell(SPELL_MORDENKAINENS_DISJUNCTION,oPC)>0) CreateItemOnObject("scribe082",oSelf,1); //Mordenkainen's Disjunction
    if (GetHasSpell(SPELL_MORDENKAINENS_SWORD,oPC)>0) CreateItemOnObject("scribe083",oSelf,1); //Mordenkainen's Sword
    if (GetHasSpell(SPELL_NEGATIVE_ENERGY_BURST,oPC)>0) CreateItemOnObject("scribe084",oSelf,1); //Negative Energy Burst
    if (GetHasSpell(SPELL_NEGATIVE_ENERGY_RAY,oPC)>0) CreateItemOnObject("scribe085",oSelf,1); //Negative Energy Ray
    if (GetHasSpell(SPELL_NEUTRALIZE_POISON,oPC)>0) CreateItemOnObject("scribe086",oSelf,1); //Neutralize Poison
    if (GetHasSpell(SPELL_OWLS_WISDOM,oPC)>0) CreateItemOnObject("scribe087",oSelf,1); //Owl's Wisdom
    if (GetHasSpell(SPELL_PHANTASMAL_KILLER,oPC)>0) CreateItemOnObject("scribe088",oSelf,1); //Phantasmal Killer
    if (GetHasSpell(SPELL_PLANAR_BINDING,oPC)>0) CreateItemOnObject("scribe089",oSelf,1); //Planar Binding
    if (GetHasSpell(SPELL_POLYMORPH_SELF,oPC)>0) CreateItemOnObject("scribe090",oSelf,1); //Polymorph Self
    if (GetHasSpell(SPELL_POWER_WORD_KILL,oPC)>0) CreateItemOnObject("scribe091",oSelf,1); //Power Word, Kill
    if (GetHasSpell(SPELL_POWER_WORD_STUN,oPC)>0) CreateItemOnObject("scribe092",oSelf,1); //Power Word, Stun
    if (GetHasSpell(SPELL_PREMONITION,oPC)>0) CreateItemOnObject("scribe093",oSelf,1); //Premonition
    if (GetHasSpell(SPELL_PRISMATIC_SPRAY,oPC)>0) CreateItemOnObject("scribe094",oSelf,1); //Prismatic Spray

    if ((GetHasSpell(SPELL_PROTECTION__FROM_CHAOS,oPC)>0)||
        (GetHasSpell(SPELL_PROTECTION_FROM_EVIL,oPC)>0)||
        (GetHasSpell(SPELL_PROTECTION_FROM_GOOD,oPC)>0)||
        (GetHasSpell(SPELL_PROTECTION_FROM_LAW,oPC)>0)) CreateItemOnObject("scribe095",oSelf,1); //Protection from Alignment


    if (GetHasSpell(SPELL_PROTECTION_FROM_ELEMENTS,oPC)>0) CreateItemOnObject("scribe096",oSelf,1); //Protection from Elements
    if (GetHasSpell(SPELL_PROTECTION_FROM_SPELLS,oPC)>0) CreateItemOnObject("scribe097",oSelf,1); //Protection from Spells
    if (GetHasSpell(SPELL_RAISE_DEAD,oPC)>0) CreateItemOnObject("scribe098",oSelf,1); //Raise Dead
    if (GetHasSpell(SPELL_RAY_OF_ENFEEBLEMENT,oPC)>0) CreateItemOnObject("scribe099",oSelf,1); //Ray of Enfeeblement
    if (GetHasSpell(SPELL_RAY_OF_FROST,oPC)>0) CreateItemOnObject("scribe100",oSelf,1); //Ray of Frost  --#100
    if (GetHasSpell(SPELL_REMOVE_BLINDNESS_AND_DEAFNESS,oPC)>0) CreateItemOnObject("scribe101",oSelf,1); //Remove Blindness/Deafness
    if (GetHasSpell(SPELL_REMOVE_CURSE,oPC)>0) CreateItemOnObject("scribe102",oSelf,1); //Remove Curse
    if (GetHasSpell(SPELL_REMOVE_DISEASE,oPC)>0) CreateItemOnObject("scribe103",oSelf,1); //Remove Disease
    if (GetHasSpell(SPELL_RESIST_ELEMENTS,oPC)>0) CreateItemOnObject("scribe104",oSelf,1); //Resist Elements
    if (GetHasSpell(SPELL_RESISTANCE,oPC)>0) CreateItemOnObject("scribe105",oSelf,1); //Resistance
    if (GetHasSpell(SPELL_RESTORATION,oPC)>0) CreateItemOnObject("scribe106",oSelf,1); //Restoration
    if (GetHasSpell(SPELL_RESURRECTION,oPC)>0) CreateItemOnObject("scribe107",oSelf,1); //Resurrection
    if (GetHasSpell(SPELL_SCARE,oPC)>0) CreateItemOnObject("scribe108",oSelf,1); //Scare
    if (GetHasSpell(SPELL_SEE_INVISIBILITY,oPC)>0) CreateItemOnObject("scribe109",oSelf,1); //See Invisibility

    if ((GetHasSpell(SPELL_SHADES_CONE_OF_COLD,oPC)>0)||
        (GetHasSpell(SPELL_SHADES_FIREBALL,oPC)>0)||
        (GetHasSpell(SPELL_SHADES_STONESKIN,oPC)>0)||
        (GetHasSpell(SPELL_SHADES_SUMMON_SHADOW,oPC)>0)||
        (GetHasSpell(SPELL_SHADES_WALL_OF_FIRE,oPC)>0)) CreateItemOnObject("scribe110",oSelf,1); //Shades

    if ((GetHasSpell(SPELL_SHADOW_CONJURATION_DARKNESS,oPC)>0)||
        (GetHasSpell(SPELL_SHADOW_CONJURATION_INIVSIBILITY,oPC)>0)||
        (GetHasSpell(SPELL_SHADOW_CONJURATION_MAGE_ARMOR,oPC)>0)||
        (GetHasSpell(SPELL_SHADOW_CONJURATION_MAGIC_MISSILE,oPC)>0)||
        (GetHasSpell(SPELL_SHADOW_CONJURATION_SUMMON_SHADOW,oPC)>0)) CreateItemOnObject("scribe111",oSelf,1); //Shadow Conjuration

    if (GetHasSpell(SPELL_SHAPECHANGE,oPC)>0) CreateItemOnObject("scribe112",oSelf,1); //Shapechange
    if (GetHasSpell(SPELL_SILENCE,oPC)>0) CreateItemOnObject("scribe113",oSelf,1); //Silence
    if (GetHasSpell(SPELL_SLEEP,oPC)>0) CreateItemOnObject("scribe114",oSelf,1); //Sleep
    if (GetHasSpell(SPELL_SLOW,oPC)>0) CreateItemOnObject("scribe115",oSelf,1); //Slow
    if (GetHasSpell(SPELL_SOUND_BURST,oPC)>0) CreateItemOnObject("scribe116",oSelf,1); //Sound Burst
    if (GetHasSpell(SPELL_SPELL_MANTLE,oPC)>0) CreateItemOnObject("scribe117",oSelf,1); //Spell Mantle
    if (GetHasSpell(SPELL_STINKING_CLOUD,oPC)>0) CreateItemOnObject("scribe118",oSelf,1); //Stinking Cloud
    if (GetHasSpell(SPELL_STONESKIN,oPC)>0) CreateItemOnObject("scribe119",oSelf,1); //Stoneskin
    if (GetHasSpell(SPELL_SUMMON_CREATURE_I,oPC)>0) CreateItemOnObject("scribe120",oSelf,1); //Summon Creature I
    if (GetHasSpell(SPELL_SUMMON_CREATURE_II,oPC)>0) CreateItemOnObject("scribe121",oSelf,1); //Summon Creature II
    if (GetHasSpell(SPELL_SUMMON_CREATURE_III,oPC)>0) CreateItemOnObject("scribe122",oSelf,1); //Summon Creature III
    if (GetHasSpell(SPELL_SUMMON_CREATURE_IV,oPC)>0) CreateItemOnObject("scribe123",oSelf,1); //Summon Creature IV
    if (GetHasSpell(SPELL_SUMMON_CREATURE_IX,oPC)>0) CreateItemOnObject("scribe124",oSelf,1); //Summon Creature IX
    if (GetHasSpell(SPELL_SUMMON_CREATURE_V,oPC)>0) CreateItemOnObject("scribe125",oSelf,1); //Summon Creature V
    if (GetHasSpell(SPELL_SUMMON_CREATURE_VI,oPC)>0) CreateItemOnObject("scribe126",oSelf,1); //Summon Creature VI
    if (GetHasSpell(SPELL_SUMMON_CREATURE_VII,oPC)>0) CreateItemOnObject("scribe127",oSelf,1); //Summon Creature VII
    if (GetHasSpell(SPELL_SUMMON_CREATURE_VIII,oPC)>0) CreateItemOnObject("scribe128",oSelf,1); //Summon Creature VIII
    if (GetHasSpell(SPELL_TENSERS_TRANSFORMATION,oPC)>0) CreateItemOnObject("scribe129",oSelf,1); //Tenser's Transformation
    if (GetHasSpell(SPELL_TIME_STOP,oPC)>0) CreateItemOnObject("scribe130",oSelf,1); //Time Stop
    if (GetHasSpell(SPELL_TRUE_SEEING,oPC)>0) CreateItemOnObject("scribe131",oSelf,1); //True Seeing

    //Comment this out if you do not wish it to always appear
    if (iCheckSpell(oPC,B2,C2,D1,P0,R1,S1,W2)==1) CreateItemOnObject("scribe132",oSelf,1); //Ultravision

    if (GetHasSpell(SPELL_VAMPIRIC_TOUCH,oPC)>0) CreateItemOnObject("scribe133",oSelf,1); //Vampiric Touch
    if (GetHasSpell(SPELL_WAIL_OF_THE_BANSHEE,oPC)>0) CreateItemOnObject("scribe134",oSelf,1); //Wail of the Banshee
    if (GetHasSpell(SPELL_WALL_OF_FIRE,oPC)>0) CreateItemOnObject("scribe135",oSelf,1); //Wall of Fire
    if (GetHasSpell(SPELL_WEB,oPC)>0) CreateItemOnObject("scribe136",oSelf,1); //Web
    if (GetHasSpell(SPELL_WEIRD,oPC)>0) CreateItemOnObject("scribe137",oSelf,1); //Weird
    if (GetHasSpell(SPELL_CURE_MINOR_WOUNDS,oPC)>0) CreateItemOnObject("scribe138",oSelf,1); //Cure Minor Wounds #138
    if (GetHasSpell(SPELL_CURE_LIGHT_WOUNDS,oPC)>0) CreateItemOnObject("scribe139",oSelf,1); //Cure Light Wounds #139
    if (GetHasSpell(SPELL_CURE_MODERATE_WOUNDS,oPC)>0) CreateItemOnObject("scribe140",oSelf,1); //Cure Moderate Wounds
    if (GetHasSpell(SPELL_CURE_SERIOUS_WOUNDS,oPC)>0) CreateItemOnObject("scribe141",oSelf,1); //Cure Serious Wounds
    if (GetHasSpell(SPELL_FIND_TRAPS,oPC)>0) CreateItemOnObject("scribe142",oSelf,1); //Find Traps
    if (GetHasSpell(SPELL_AID,oPC)>0) CreateItemOnObject("scribe143",oSelf,1); //Aid
    if (GetHasSpell(SPELL_AURA_OF_VITALITY,oPC)>0) CreateItemOnObject("scribe144",oSelf,1); //Aura of Vitality

    //Comment this out if you do not wish it to always appear
    if (iCheckSpell(oPC,B0,C8,D0,P0,R0,S0,W0)==1) CreateItemOnObject("scribe145",oSelf,1); //Aura versus Alignment

    if (GetHasSpell(SPELL_AWAKEN,oPC)>0) CreateItemOnObject("scribe146",oSelf,1); //Awaken
    if (GetHasSpell(SPELL_BARKSKIN,oPC)>0) CreateItemOnObject("scribe147",oSelf,1); //BarkSkin
    if (GetHasSpell(SPELL_BLADE_BARRIER,oPC)>0) CreateItemOnObject("scribe148",oSelf,1); //Blade Barrier
    if (GetHasSpell(SPELL_BLESS,oPC)>0) CreateItemOnObject("scribe149",oSelf,1); //Bless
    if (GetHasSpell(SPELL_CALL_LIGHTNING,oPC)>0) CreateItemOnObject("scribe150",oSelf,1); //Call Lightning #150
    if (GetHasSpell(SPELL_CIRCLE_OF_DOOM,oPC)>0) CreateItemOnObject("scribe151",oSelf,1); //Circle of Doom
    if (GetHasSpell(SPELL_CREATE_GREATER_UNDEAD,oPC)>0) CreateItemOnObject("scribe152",oSelf,1); //Create Greater Undead
    if (GetHasSpell(SPELL_CREATE_UNDEAD,oPC)>0) CreateItemOnObject("scribe153",oSelf,1); //Create Undead
    if (GetHasSpell(SPELL_CREEPING_DOOM,oPC)>0) CreateItemOnObject("scribe154",oSelf,1); //Creeping Doom
    if (GetHasSpell(SPELL_CURE_CRITICAL_WOUNDS,oPC)>0) CreateItemOnObject("scribe155",oSelf,1); //Cure Critical Wounds
    if (GetHasSpell(SPELL_DEATH_WARD,oPC)>0) CreateItemOnObject("scribe156",oSelf,1); //Death Ward
    if (GetHasSpell(SPELL_DESTRUCTION,oPC)>0) CreateItemOnObject("scribe157",oSelf,1); //Destruction
    if (GetHasSpell(SPELL_DIVINE_POWER,oPC)>0) CreateItemOnObject("scribe158",oSelf,1); //Divine Power
    if (GetHasSpell(SPELL_DOMINATE_ANIMAL,oPC)>0) CreateItemOnObject("scribe159",oSelf,1); //Dominate Animal
    if (GetHasSpell(SPELL_DOOM,oPC)>0) CreateItemOnObject("scribe160",oSelf,1); //Doom #160
    if (GetHasSpell(SPELL_ELEMENTAL_SWARM,oPC)>0) CreateItemOnObject("scribe161",oSelf,1); //Elemental Swarm
    if (GetHasSpell(SPELL_ENERGY_BUFFER,oPC)>0) CreateItemOnObject("scribe162",oSelf,1); //Energy Buffer
    if (GetHasSpell(SPELL_ENTANGLE,oPC)>0) CreateItemOnObject("scribe163",oSelf,1); //Entangle
    if (GetHasSpell(SPELL_EVARDS_BLACK_TENTACLES,oPC)>0) CreateItemOnObject("scribe164",oSelf,1); //Evard's Black Tentacles
    if (GetHasSpell(SPELL_FIRE_STORM,oPC)>0) CreateItemOnObject("scribe165",oSelf,1); //Fire Storm
    if (GetHasSpell(SPELL_FLAME_LASH,oPC)>0) CreateItemOnObject("scribe166",oSelf,1); //Flame Lash
    if (GetHasSpell(SPELL_FLAME_STRIKE,oPC)>0) CreateItemOnObject("scribe167",oSelf,1); //Flame Strike
    if (GetHasSpell(SPELL_FREEDOM_OF_MOVEMENT,oPC)>0) CreateItemOnObject("scribe168",oSelf,1); //Freedom of Movement
    if (GetHasSpell(SPELL_HAMMER_OF_THE_GODS,oPC)>0) CreateItemOnObject("scribe169",oSelf,1); //Hammer of the Gods
    if (GetHasSpell(SPELL_HARM,oPC)>0) CreateItemOnObject("scribe170",oSelf,1); //Harm #170
    if (GetHasSpell(SPELL_HEAL,oPC)>0) CreateItemOnObject("scribe171",oSelf,1); //Heal
    if (GetHasSpell(SPELL_HEALING_CIRCLE,oPC)>0) CreateItemOnObject("scribe172",oSelf,1); //Healing Circle
    if (GetHasSpell(SPELL_HOLD_ANIMAL,oPC)>0) CreateItemOnObject("scribe173",oSelf,1); //Hold Animal
    if (GetHasSpell(SPELL_ICE_STORM,oPC)>0) CreateItemOnObject("scribe174",oSelf,1); //Ice Storm
    if (GetHasSpell(SPELL_IMPLOSION,oPC)>0) CreateItemOnObject("scribe175",oSelf,1); //Implosion
    if (GetHasSpell(SPELL_INVISIBILITY_PURGE,oPC)>0) CreateItemOnObject("scribe176",oSelf,1); //Invisibility Purge
    if (GetHasSpell(SPELL_LEGEND_LORE,oPC)>0) CreateItemOnObject("scribe177",oSelf,1); //Legend Lore
    if (GetHasSpell(SPELL_MASS_HEAL,oPC)>0) CreateItemOnObject("scribe178",oSelf,1); //Mass Heal
    if (GetHasSpell(SPELL_NATURES_BALANCE,oPC)>0) CreateItemOnObject("scribe179",oSelf,1); //Nature's Balance
    if (GetHasSpell(SPELL_NEGATIVE_ENERGY_PROTECTION,oPC)>0) CreateItemOnObject("scribe180",oSelf,1); //Negative Energy Protection #180
    if (GetHasSpell(SPELL_POISON,oPC)>0) CreateItemOnObject("scribe181",oSelf,1); //Poison
    if (GetHasSpell(SPELL_PRAYER,oPC)>0) CreateItemOnObject("scribe182",oSelf,1); //Prayer
    if (GetHasSpell(SPELL_REGENERATE,oPC)>0) CreateItemOnObject("scribe183",oSelf,1); //Regenerate
    if (GetHasSpell(SPELL_REMOVE_FEAR,oPC)>0) CreateItemOnObject("scribe184",oSelf,1); //Remove Fear
    if (GetHasSpell(SPELL_REMOVE_PARALYSIS,oPC)>0) CreateItemOnObject("scribe185",oSelf,1); //Remove Paralysis
    if (GetHasSpell(SPELL_SANCTUARY,oPC)>0) CreateItemOnObject("scribe186",oSelf,1); //Sanctuary
    if (GetHasSpell(SPELL_SEARING_LIGHT,oPC)>0) CreateItemOnObject("scribe187",oSelf,1); //Searing Light
    if (GetHasSpell(SPELL_SHADOW_SHIELD,oPC)>0) CreateItemOnObject("scribe188",oSelf,1); //Shadow Shield
    if (GetHasSpell(SPELL_SLAY_LIVING,oPC)>0) CreateItemOnObject("scribe189",oSelf,1); //Slay Living
    if (GetHasSpell(SPELL_SPELL_RESISTANCE,oPC)>0) CreateItemOnObject("scribe190",oSelf,1); //Spell Resistance #190
    if (GetHasSpell(SPELL_STORM_OF_VENGEANCE,oPC)>0) CreateItemOnObject("scribe191",oSelf,1); //Storm of Vengeance
    if (GetHasSpell(SPELL_SUNBEAM,oPC)>0) CreateItemOnObject("scribe192",oSelf,1); //Sunbeam
    if (GetHasSpell(SPELL_VIRTUE,oPC)>0) CreateItemOnObject("scribe193",oSelf,1); //Virtue
    if (GetHasSpell(SPELL_WAR_CRY,oPC)>0) CreateItemOnObject("scribe194",oSelf,1); //War Cry
    if (GetHasSpell(SPELL_WORD_OF_FAITH,oPC)>0) CreateItemOnObject("scribe195",oSelf,1); //Word of Faith


    if (GetHasSpell(SPELL_ACID_SPLASH,oPC)>0) CreateItemOnObject("scribe197",oSelf,1); //Acid Splash
    if (GetHasSpell(SPELL_AMPLIFY,oPC)>0) CreateItemOnObject("scribe198",oSelf,1); //Amplify
    if (GetHasSpell(SPELL_AURAOFGLORY,oPC)>0) CreateItemOnObject("scribe199",oSelf,1); //Aura of Glory
    if (GetHasSpell(SPELL_BALAGARNSIRONHORN,oPC)>0) CreateItemOnObject("scribe200",oSelf,1); //Balagarn's Iron Horn
    if (GetHasSpell(SPELL_BANE,oPC)>0) CreateItemOnObject("scribe201",oSelf,1); //Bane
    if (GetHasSpell(SPELL_BIGBYS_CLENCHED_FIST,oPC)>0) CreateItemOnObject("scribe202",oSelf,1); //Bigby's Clenched Fist
    if (GetHasSpell(SPELL_BIGBYS_CRUSHING_HAND,oPC)>0) CreateItemOnObject("scribe203",oSelf,1); //Bigby's Crushing Hand
    if (GetHasSpell(SPELL_BIGBYS_FORCEFUL_HAND,oPC)>0) CreateItemOnObject("scribe204",oSelf,1); //Bigby's Forceful Hand
    if (GetHasSpell(SPELL_BIGBYS_GRASPING_HAND,oPC)>0) CreateItemOnObject("scribe205",oSelf,1); //Bigby's Grasping Hand
    if (GetHasSpell(SPELL_BIGBYS_INTERPOSING_HAND,oPC)>0) CreateItemOnObject("scribe206",oSelf,1); //Bigby's Interposing Hand
    if (GetHasSpell(SPELL_BLOOD_FRENZY,oPC)>0) CreateItemOnObject("scribe207",oSelf,1); //Blood Frenzy
    if (GetHasSpell(SPELL_BOMBARDMENT,oPC)>0) CreateItemOnObject("scribe208",oSelf,1); //Bombardment
    if (GetHasSpell(SPELL_CONTINUAL_FLAME,oPC)>0) CreateItemOnObject("scribe209",oSelf,1); //Continual Flame
    if (GetHasSpell(SPELL_DIRGE,oPC)>0) CreateItemOnObject("scribe210",oSelf,1); //Dirge
    if (GetHasSpell(SPELL_DISPLACEMENT,oPC)>0) CreateItemOnObject("scribe211",oSelf,1); //Displacement
    if (GetHasSpell(SPELL_DIVINE_FAVOR,oPC)>0) CreateItemOnObject("scribe212",oSelf,1); //Divine Favor
    if (GetHasSpell(SPELL_DIVINE_MIGHT,oPC)>0) CreateItemOnObject("scribe213",oSelf,1); //Divine Might
    if (GetHasSpell(SPELL_DROWN,oPC)>0) CreateItemOnObject("scribe214",oSelf,1); //Drown
    if (GetHasSpell(SPELL_ELECTRIC_JOLT,oPC)>0) CreateItemOnObject("scribe215",oSelf,1); //Electric Jolt
    if (GetHasSpell(SPELL_ENTROPIC_SHIELD,oPC)>0) CreateItemOnObject("scribe216",oSelf,1); //Entropic Shield
    if (GetHasSpell(SPELL_EXPEDITIOUS_RETREAT,oPC)>0) CreateItemOnObject("scribe217",oSelf,1); //Expeditious Retreat
    if (GetHasSpell(SPELL_FIREBRAND,oPC)>0) CreateItemOnObject("scribe218",oSelf,1); //Firebrand
    if (GetHasSpell(SPELL_FLARE,oPC)>0) CreateItemOnObject("scribe219",oSelf,1); //Flare
    if (GetHasSpell(SPELL_FLESH_TO_STONE,oPC)>0) CreateItemOnObject("scribe220",oSelf,1); //Flesh To Stone
    if (GetHasSpell(SPELL_GREATER_MAGIC_FANG,oPC)>0) CreateItemOnObject("scribe221",oSelf,1); //Greater Magic Fang

    //Comment this line out if you do not wish this spell to always appear in the scribe's list
    if (iCheckSpell(oPC,B0,C6,D0,P0,R0,S8,W8)==1) CreateItemOnObject("scribe222",oSelf,1); //Greater Sanctuary

    if (GetHasSpell(SPELL_GUST_OF_WIND,oPC)>0) CreateItemOnObject("scribe223",oSelf,1); //Gust of Wind
    if (GetHasSpell(SPELL_INFERNO,oPC)>0) CreateItemOnObject("scribe224",oSelf,1); //Inferno
    if (GetHasSpell(SPELL_INFLICT_CRITICAL_WOUNDS,oPC)>0) CreateItemOnObject("scribe225",oSelf,1); //Inflict Critical Wounds
    if (GetHasSpell(SPELL_INFLICT_LIGHT_WOUNDS,oPC)>0) CreateItemOnObject("scribe226",oSelf,1); //Inflict Light Wounds
    if (GetHasSpell(SPELL_INFLICT_MINOR_WOUNDS,oPC)>0) CreateItemOnObject("scribe227",oSelf,1); //Inflict Minor Wounds
    if (GetHasSpell(SPELL_INFLICT_MODERATE_WOUNDS,oPC)>0) CreateItemOnObject("scribe228",oSelf,1); //Inflict Moderate wounds
    if (GetHasSpell(SPELL_INFLICT_SERIOUS_WOUNDS,oPC)>0) CreateItemOnObject("scribe229",oSelf,1); //Inflict Serious Wounds
    if (GetHasSpell(SPELL_ISAACS_LESSER_MISSILE_STORM,oPC)>0) CreateItemOnObject("scribe230",oSelf,1); //Isaac's Lesser Missile Storm
    if (GetHasSpell(SPELL_ISAACS_GREATER_MISSILE_STORM,oPC)>0) CreateItemOnObject("scribe231",oSelf,1); //Isaac's Greater Missile Storm
    if (GetHasSpell(SPELL_MAGIC_FANG,oPC)>0) CreateItemOnObject("scribe232",oSelf,1); //Magic Fang
    if (GetHasSpell(SPELL_MASS_CAMOFLAGE,oPC)>0) CreateItemOnObject("scribe233",oSelf,1); //Mass Camouflage
    if (GetHasSpell(SPELL_ONE_WITH_THE_LAND,oPC)>0) CreateItemOnObject("scribe234",oSelf,1); //One With The Land

    //Comment this line out if you do not wish this spell to always appear in the scribe's list
    if (iCheckSpell(oPC,B0,C0,D5,P0,R0,S0,W0)==1) CreateItemOnObject("scribe235",oSelf,1); //Owl's Insight (#235)

    if (GetHasSpell(SPELL_PLANAR_ALLY,oPC)>0) CreateItemOnObject("scribe236",oSelf,1); //Planar Ally
    if (GetHasSpell(SPELL_QUILLFIRE,oPC)>0) CreateItemOnObject("scribe237",oSelf,1); //Quillfire
    if (GetHasSpell(SPELL_SHIELD,oPC)>0) CreateItemOnObject("scribe238",oSelf,1); //Shield
    if (GetHasSpell(SPELL_SHIELD_OF_FAITH,oPC)>0) CreateItemOnObject("scribe239",oSelf,1); //Shield of Faith
    if (GetHasSpell(SPELL_SPIKE_GROWTH,oPC)>0) CreateItemOnObject("scribe240",oSelf,1); //Spike Growth
    if (GetHasSpell(SPELL_STONE_TO_FLESH,oPC)>0) CreateItemOnObject("scribe241",oSelf,1); //Stone To Flesh
    if (GetHasSpell(SPELL_SUNBURST,oPC)>0) CreateItemOnObject("scribe242",oSelf,1); //Sunburst
    if (GetHasSpell(SPELL_TASHAS_HIDEOUS_LAUGHTER,oPC)>0) CreateItemOnObject("scribe243",oSelf,1); //Tasha's Hideous Laughter
    if (GetHasSpell(SPELL_TRUE_STRIKE,oPC)>0) CreateItemOnObject("scribe244",oSelf,1); //True Strike
    if (GetHasSpell(SPELL_UNDEATHS_ETERNAL_FOE,oPC)>0) CreateItemOnObject("scribe245",oSelf,1); //Undeath's Eternal Foe
    if (GetHasSpell(SPELL_WOUNDING_WHISPERS,oPC)>0) CreateItemOnObject("scribe246",oSelf,1); //Wounding Whispers



   }

  if (iThiefLevel>6) CreateItemOnObject("scribe196",oSelf,1); //Rogue's Cunning










}

int iCheckSpell(object oPC, int iBard, int iCleric, int iDruid, int iPaladin, int iRanger, int iSorcerer, int iWizard)
 {
  if (iSorcerer>0)
   {
    if (GetLevelByClass(CLASS_TYPE_SORCERER,oPC)>=iSorcerer) return 1;
   }
  if (iWizard>0)
   {
    if (GetLevelByClass(CLASS_TYPE_WIZARD,oPC)>=iWizard) return 1;
   }if (iBard>0)
   {
    if (GetLevelByClass(CLASS_TYPE_BARD,oPC)>=iBard) return 1;
   }
  if (iCleric>0)
   {
    if (GetLevelByClass(CLASS_TYPE_CLERIC,oPC)>=iCleric) return 1;
   }
  if (iDruid>0)
   {
    if (GetLevelByClass(CLASS_TYPE_DRUID,oPC)>=iDruid) return 1;
   }
  if (iPaladin>0)
   {
    if (GetLevelByClass(CLASS_TYPE_PALADIN,oPC)>=iPaladin) return 1;
   }
  if (iRanger>0)
   {
    if (GetLevelByClass(CLASS_TYPE_RANGER,oPC)>=iRanger) return 1;
   }
  return 0;
 }
