//============================================================================
//
// Name: CS Resting Subsystem - Text display strings
// File: cs_rest_text
// Author: Craig Smith (Galap) <craig@smith.dropbear.id.au>
//
// $Id: cs_rest_text.nss,v 1.6 2004/12/29 10:17:08 cs Exp $
// $Source: /local/cvs/nwn/resting/cs_rest_text.nss,v $
//
//----------------------------------------------------------------------------
// This software is distributed in the hope that it will be useful. It is
// provided "as is" WITHOUT WARRANTY OF ANY KIND, either expressed or implied,
// including, but not limited to, the implied warranties of merchantability
// and fitness for a particular purpose. You may redistribute or modify this
// software for your own purposes so long as all original credit information
// remains intact.
//----------------------------------------------------------------------------
//
// This file contains the text strings displayed as floating text on players
// when resting events occur. Changing these strings will change the messages
// displayed to all players when resting anywhere in the module. If you wish
// to change the messages only for specific area or triggers, consult the
// documentation and check the description for the CS Rest: Text Messages
// configuration item.
//
//============================================================================

const string CS_REST_MSG_START = "You have begun to rest";
const string CS_REST_MSG_FINISH = "You have finished resting";
const string CS_REST_MSG_CANCEL = "Your rest has been interrupted";
const string CS_REST_MSG_CANNOT = "You may not rest at this time";
const string CS_REST_MSG_TOO_SOON = "You may rest again in <MIN>";
const string CS_REST_MSG_DAY_ONLY = "You may not rest here at night";
const string CS_REST_MSG_NIGHT_ONLY = "You may not rest here during the day";
const string CS_REST_MSG_NO_ARMOUR = "You may not rest while wearing armour";
const string CS_REST_MSG_NO_WEAPON = "You may not rest while carrying weapons";
const string CS_REST_MSG_BEDROLL_RUINED = "You rest but your bedroll is now in tatters";
const string CS_REST_MSG_NOT_COMFORTABLE = "You are unable to become comfortable and cannot rest properly";
const string CS_REST_MSG_ENTER_REST = "You have entered a resting zone";
const string CS_REST_MSG_EXIT_REST = "You have left a resting zone";
const string CS_REST_MSG_UNSAFE = "You may not rest in unsafe conditions";
const string CS_REST_MSG_ENTER_NO_REST = "You have entered a zone that does not permit resting";
const string CS_REST_MSG_EXIT_NO_REST = "You have left a zone that does not permit resting";
const string CS_REST_MSG_NO_BEDROLL = "You may not rest without a bedroll";

