const string CustomSetScriptSet             = "CustomSetScriptSet";

const string CustomSet_OnBlocked            = "OnBlocked";
const string CustomSet_OnDamaged            = "OnDamaged";
const string CustomSet_OnDeath              = "OnDeath";
const string CustomSet_OnConversation       = "OnConversation";
const string CustomSet_OnDisturbed          = "OnDisturbed";
const string CustomSet_OnCombatRoundEnd     = "OnCombatRoundEnd";
const string CustomSet_OnHeartbeat          = "OnHeartbeat";
const string CustomSet_OnPhysicalAttacked   = "OnPhysicalAttacked";
const string CustomSet_OnPerception         = "OnPerception";
const string CustomSet_OnRested             = "OnRested";
const string CustomSet_OnSpawn              = "OnSpawn";
const string CustomSet_OnSpellCast          = "OnSpellCast";
const string CustomSet_OnUserDefined        = "OnUserDefined";

//Default script sets
const int CustomSet_DefaultSet              = 1;
const int CustomSet_HenchManSet             = 2;
const int CustomSet_X2_DefaultSet           = 3;

//  Makes target execute the custom_spawn script.
void    CustomSet_respawn(object target=OBJECT_SELF);
//  Earase all scripts set on target.
void    CustomSet_ClearScripts(object target=OBJECT_SELF);

//  Returns the set of script used by target or 0 if none is set.
int     GetCustomSetScriptSet(object target = OBJECT_SELF);
//  Sets the set of script that target should use. You may have to call
//  CustomSet_respawn.
void    SetCustomSetScriptSet(int scriptSet = CustomSet_DefaultSet,object target = OBJECT_SELF);

//  Returns the script associated with an event.
string  GetCustomSet_OnBlocked(object target = OBJECT_SELF);
//  Links a script with an event.
void    SetCustomSet_OnBlocked(string script,object target = OBJECT_SELF);

//  Returns the script associated with an event.
string  GetCustomSet_OnDamaged(object target = OBJECT_SELF);
//  Links a script with an event.
void    SetCustomSet_OnDamaged(string script,object target = OBJECT_SELF);

//  Returns the script associated with an event.
string  GetCustomSet_OnDeath(object target = OBJECT_SELF);
//  Links a script with an event.
void    SetCustomSet_OnDeath(string script,object target = OBJECT_SELF);

//  Returns the script associated with an event.
string  GetCustomSet_OnConversation(object target = OBJECT_SELF);
//  Links a script with an event.
void    SetCustomSet_OnConversation(string script,object target = OBJECT_SELF);

//  Returns the script associated with an event.
string  GetCustomSet_OnDisturbed(object target = OBJECT_SELF);
//  Links a script with an event.
void    SetCustomSet_OnDisturbed(string script,object target = OBJECT_SELF);

//  Returns the script associated with an event.
string  GetCustomSet_OnCombatRoundEnd(object target = OBJECT_SELF);
//  Links a script with an event.
void    SetCustomSet_OnCombatRoundEnd(string script,object target = OBJECT_SELF);

//  Returns the script associated with an event.
string  GetCustomSet_OnHeartbeat(object target = OBJECT_SELF);
//  Links a script with an event.
void    SetCustomSet_OnHeartbeat(string script,object target = OBJECT_SELF);

//  Returns the script associated with an event.
string  GetCustomSet_OnPhysicalAttacked(object target = OBJECT_SELF);
//  Links a script with an event.
void    SetCustomSet_OnPhysicalAttacked(string script,object target = OBJECT_SELF);

//  Returns the script associated with an event.
string  GetCustomSet_OnPerception(object target = OBJECT_SELF);
//  Links a script with an event.
void    SetCustomSet_OnPerception(string script,object target = OBJECT_SELF);

//  Returns the script associated with an event.
string  GetCustomSet_OnRested(object target = OBJECT_SELF);
//  Links a script with an event.
void    SetCustomSet_OnRested(string script,object target = OBJECT_SELF);

//  Returns the script associated with an event.
string  GetCustomSet_OnSpawn(object target = OBJECT_SELF);
//  Links a script with an event.
void    SetCustomSet_OnSpawn(string script,object target = OBJECT_SELF);

//  Returns the script associated with an event.
string  GetCustomSet_OnSpellCast(object target = OBJECT_SELF);
//  Links a script with an event.
void    SetCustomSet_OnSpellCast(string script,object target = OBJECT_SELF);

//  Returns the script associated with an event.
string  GetCustomSet_OnUserDefined(object target = OBJECT_SELF);
//  Links a script with an event.
void    SetCustomSet_OnUserDefined(string script,object target = OBJECT_SELF);










void CustomSet_respawn(object target=OBJECT_SELF)
{
    ExecuteScript("custom_spawn",target);
}

void CustomSet_ClearScripts(object target=OBJECT_SELF)
{
    DeleteLocalString(target,CustomSet_OnBlocked);
    DeleteLocalString(target,CustomSet_OnDamaged);
    DeleteLocalString(target,CustomSet_OnDeath);
    DeleteLocalString(target,CustomSet_OnConversation);
    DeleteLocalString(target,CustomSet_OnDisturbed);
    DeleteLocalString(target,CustomSet_OnCombatRoundEnd);
    DeleteLocalString(target,CustomSet_OnHeartbeat);
    DeleteLocalString(target,CustomSet_OnPhysicalAttacked);
    DeleteLocalString(target,CustomSet_OnPerception);
    DeleteLocalString(target,CustomSet_OnRested);
    DeleteLocalString(target,CustomSet_OnSpawn);
    DeleteLocalString(target,CustomSet_OnSpellCast);
    DeleteLocalString(target,CustomSet_OnUserDefined);
}

void    SetCustomSetScriptSet(int scriptSet = CustomSet_DefaultSet,object target = OBJECT_SELF)
{
    SetLocalInt(target,CustomSetScriptSet,scriptSet);
}
int     GetCustomSetScriptSet(object target = OBJECT_SELF)
{
    return GetLocalInt(target,CustomSetScriptSet);
}

string  GetCustomSet_OnBlocked(object target = OBJECT_SELF)
{
    return GetLocalString(target,CustomSet_OnBlocked);
}
void    SetCustomSet_OnBlocked(string script,object target = OBJECT_SELF)
{
    SetLocalString(target,CustomSet_OnBlocked,script);
}

string  GetCustomSet_OnDamaged(object target = OBJECT_SELF)
{
    return GetLocalString(target,CustomSet_OnDamaged);
}
void    SetCustomSet_OnDamaged(string script,object target = OBJECT_SELF)
{
    SetLocalString(target,CustomSet_OnDamaged,script);
}

string  GetCustomSet_OnDeath(object target = OBJECT_SELF)

{
    return GetLocalString(target,CustomSet_OnDeath);
}
void    SetCustomSet_OnDeath(string script,object target = OBJECT_SELF)
{
    SetLocalString(target,CustomSet_OnDeath,script);
}

string  GetCustomSet_OnConversation(object target = OBJECT_SELF)

{
    return GetLocalString(target,CustomSet_OnConversation);
}
void    SetCustomSet_OnConversation(string script,object target = OBJECT_SELF)
{
    SetLocalString(target,CustomSet_OnConversation,script);
}

string  GetCustomSet_OnDisturbed(object target = OBJECT_SELF)

{
    return GetLocalString(target,CustomSet_OnDisturbed);
}
void    SetCustomSet_OnDisturbed(string script,object target = OBJECT_SELF)
{
    SetLocalString(target,CustomSet_OnDisturbed,script);
}

string  GetCustomSet_OnCombatRoundEnd(object target = OBJECT_SELF)

{
    return GetLocalString(target,CustomSet_OnCombatRoundEnd);
}
void    SetCustomSet_OnCombatRoundEnd(string script,object target = OBJECT_SELF)
{
    SetLocalString(target,CustomSet_OnCombatRoundEnd,script);
}

string  GetCustomSet_OnHeartbeat(object target = OBJECT_SELF)
{
    return GetLocalString(target,CustomSet_OnHeartbeat);
}
void    SetCustomSet_OnHeartbeat(string script,object target = OBJECT_SELF)
{
    SetLocalString(target,CustomSet_OnHeartbeat,script);
}

string  GetCustomSet_OnPhysicalAttacked(object target = OBJECT_SELF)
{
    return GetLocalString(target,CustomSet_OnPhysicalAttacked);
}
void    SetCustomSet_OnPhysicalAttacked(string script,object target = OBJECT_SELF)
{
    SetLocalString(target,CustomSet_OnPhysicalAttacked,script);
}

string  GetCustomSet_OnPerception(object target = OBJECT_SELF)
{
    return GetLocalString(target,CustomSet_OnPerception);
}
void    SetCustomSet_OnPerception(string script,object target = OBJECT_SELF)
{
    SetLocalString(target,CustomSet_OnPerception,script);
}

string  GetCustomSet_OnRested(object target = OBJECT_SELF)
{
    return GetLocalString(target,CustomSet_OnRested);
}
void    SetCustomSet_OnRested(string script,object target = OBJECT_SELF)
{
    SetLocalString(target,CustomSet_OnRested,script);
}

string  GetCustomSet_OnSpawn(object target = OBJECT_SELF)
{
    return GetLocalString(target,CustomSet_OnSpawn);
}
void    SetCustomSet_OnSpawn(string script,object target = OBJECT_SELF)
{
    SetLocalString(target,CustomSet_OnSpawn,script);
}

string  GetCustomSet_OnSpellCast(object target = OBJECT_SELF)
{
    return GetLocalString(target,CustomSet_OnSpellCast);
}
void    SetCustomSet_OnSpellCast(string script,object target = OBJECT_SELF)
{
    SetLocalString(target,CustomSet_OnSpellCast,script);
}


string  GetCustomSet_OnUserDefined(object target = OBJECT_SELF)
{
    return GetLocalString(target,CustomSet_OnUserDefined);
}
void    SetCustomSet_OnUserDefined(string script,object target = OBJECT_SELF)
{
    SetLocalString(target,CustomSet_OnUserDefined,script);
}
