int GetHasProtection(object oPC)
{
    effect eEff = GetFirstEffect(oPC);
    while (GetIsEffectValid(eEff)) {
        if (GetEffectType(eEff) == EFFECT_TYPE_AC_INCREASE)
            return TRUE;
        eEff = GetNextEffect(oPC);
    }
    return FALSE;
}

void main()
{
    // Get the stored target
    object oPC = GetLastUsedBy();
    if (!GetIsObjectValid(oPC))
        return;

    // Don't reapply if we're already protected
    if (GetHasProtection(oPC))
        return;

    // if the oracle effect is off, reapply it
    effect eBless = EffectACIncrease(3,AC_DODGE_BONUS,AC_VS_DAMAGE_TYPE_ALL);
    effect eVis = EffectVisualEffect(VFX_DUR_PROT_BARKSKIN);

    //Link the visual and the damage reduction effect
    //delayed to ensure praying has finished
    effect eLink = EffectLinkEffects(eBless, eVis);
    DelayCommand(15.0,ApplyEffectToObject(DURATION_TYPE_PERMANENT, eLink, oPC));

    //Visual effect of the blessing being received
    ApplyEffectToObject(DURATION_TYPE_INSTANT,EffectVisualEffect(VFX_FNF_DISPEL_DISJUNCTION),oPC);
}
