int GetHasProtection(object oPC)
{
    effect eEff = GetFirstEffect(oPC);
    while (GetIsEffectValid(eEff)) {
        if (GetEffectType(eEff) == EFFECT_TYPE_DAMAGE_RESISTANCE)
            return TRUE;
        eEff = GetNextEffect(oPC);
    }
    return FALSE;
}

void main()
{
    // Get the stored target
    object oPC = GetLastUsedBy();
    if (!GetIsObjectValid(oPC))
        return;

    // Don't reapply if we're already protected
    if (GetHasProtection(oPC))
        return;

    // if the oracle effect is off, reapply it
    effect eBless = EffectDamageResistance(DAMAGE_TYPE_SONIC,10);
    effect eBless1 = EffectDamageResistance(DAMAGE_TYPE_FIRE,10);
    effect eBless2 = EffectDamageResistance(DAMAGE_TYPE_COLD,10);
    effect eBless3 = EffectDamageResistance(DAMAGE_TYPE_ELECTRICAL,10);
    effect eVis = EffectVisualEffect(VFX_DUR_ELEMENTAL_SHIELD);

    //Link the visual and the damage reduction effect
    //delayed to ensure praying has finished
    effect eLink = EffectLinkEffects(eBless, eVis);
           eLink = EffectLinkEffects(eLink, eBless1);
           eLink = EffectLinkEffects(eLink, eBless2);
           eLink = EffectLinkEffects(eLink, eBless3);
    DelayCommand(15.0,ApplyEffectToObject(DURATION_TYPE_PERMANENT, eLink, oPC));

    //Visual effect of the blessing being received
    ApplyEffectToObject(DURATION_TYPE_INSTANT,EffectVisualEffect(VFX_FNF_ELECTRIC_EXPLOSION),oPC);
}
