int GetHasProtection(object oPC)
{
    effect eEff = GetFirstEffect(oPC);
    while (GetIsEffectValid(eEff)) {
        if (GetEffectType(eEff) == EFFECT_TYPE_CONCEALMENT)
            return TRUE;
        eEff = GetNextEffect(oPC);
    }
    return FALSE;
}

void main()
{
    // Get the stored target
    object oPC = GetLastUsedBy();
    if (!GetIsObjectValid(oPC))
        return;

    // Don't reapply if we're already protected
    if (GetHasProtection(oPC))
        return;

    // if the oracle effect is off, reapply it
    effect eBless = EffectConcealment(20,MISS_CHANCE_TYPE_VS_MELEE);
    effect eBless1 = EffectConcealment(40,MISS_CHANCE_TYPE_VS_RANGED);
    effect eVis = EffectVisualEffect(VFX_DUR_GHOSTLY_VISAGE);

    //Link the visual and the damage reduction effect
    //delayed to ensure praying has finished
    effect eLink = EffectLinkEffects(eBless, eVis);
           eLink = EffectLinkEffects(eLink, eBless1);
    DelayCommand(15.0,ApplyEffectToObject(DURATION_TYPE_PERMANENT, eLink, oPC));

    //Visual effect of the blessing being received
    ApplyEffectToObject(DURATION_TYPE_INSTANT,EffectVisualEffect(VFX_FNF_NATURES_BALANCE),oPC);
}
