int GetHasProtection(object oPC)
{
    effect eEff = GetFirstEffect(oPC);
    while (GetIsEffectValid(eEff)) {
        if (GetEffectType(eEff) == EFFECT_TYPE_IMMUNITY)
            return TRUE;
        eEff = GetNextEffect(oPC);
    }
    return FALSE;
}

void main()
{
    // Get the stored target
    object oPC = GetLastUsedBy();
    if (!GetIsObjectValid(oPC))
        return;

    // Don't reapply if we're already protected
    if (GetHasProtection(oPC))
        return;

    // if the oracle effect is off, reapply it
    effect eBless = EffectImmunity(IMMUNITY_TYPE_POISON);
    effect eVis = EffectVisualEffect(VFX_DUR_FLIES);
    effect eBless2 = EffectImmunity(IMMUNITY_TYPE_DISEASE);

    //Link the visual and the damage reduction effect
    //delayed to ensure praying has finished
    effect eLink = EffectLinkEffects(eBless, eVis);
    effect eLink2 = EffectLinkEffects(eLink, eBless2);
    DelayCommand(15.0,ApplyEffectToObject(DURATION_TYPE_PERMANENT, eLink2, oPC));

    //Visual effect of the blessing being received
    ApplyEffectToObject(DURATION_TYPE_INSTANT,EffectVisualEffect(VFX_FNF_METEOR_SWARM),oPC);
}
