int GetHasProtection(object oPC)
{
    effect eEff = GetFirstEffect(oPC);
    while (GetIsEffectValid(eEff)) {
        if (GetEffectType(eEff) == EFFECT_TYPE_SPELLLEVELABSORPTION)
            return TRUE;
        eEff = GetNextEffect(oPC);
    }
    return FALSE;
}

void main()
{
    // Get the stored target
    object oPC = GetLastUsedBy();
    if (!GetIsObjectValid(oPC))
        return;

    // Don't reapply if we're already protected
    if (GetHasProtection(oPC))
        return;

    // if the oracle effect is off, reapply it
        effect eBless1 = EffectDamageIncrease(DAMAGE_BONUS_3,DAMAGE_TYPE_MAGICAL);
        effect eBless2 = EffectSpellLevelAbsorption(1,SPELL_SCHOOL_GENERAL);
        effect eDur = EffectVisualEffect(VFX_DUR_IOUNSTONE_RED);

    //Link the visual and the damage reduction effect
    //delayed to ensure praying has finished
        effect eLink = EffectLinkEffects(eBless1, eBless2);
               eLink = EffectLinkEffects(eLink,eDur);
        DelayCommand(15.0,ApplyEffectToObject(DURATION_TYPE_PERMANENT, eLink, oPC));

    //Visual effect of the blessing being received
    ApplyEffectToObject(DURATION_TYPE_INSTANT,EffectVisualEffect(VFX_FNF_LOS_NORMAL_30),oPC);
}
